# -*- coding: utf-8 -*-
#
# File: GoReplacement.py
#
# Copyright (c) 2007 by []
# Generator: ArchGenXML Version 1.5.1-svn
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Georg Gogo. BERNHARD <g.bernhard@akbild.ac.at>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *

try:
    from Products.LinguaPlone.public import *
except ImportError:
    HAS_LINGUAPLONE = False
else:
    HAS_LINGUAPLONE = True

from Products.GoReplace.config import *

# additional imports from tagged value 'import'
from Products.ATContentTypes.content.topic import ATTopic

##code-section module-header #fill in your manual code here
import re
import logging
logger = logging.getLogger('GoReplace')
##/code-section module-header

schema = Schema((

    TextField(
        name='find',
        default="""(?is)<a(.*?)href=['"](.*?)['"](.*?)>""",
        widget=TextAreaWidget(
            label='Find',
            label_msgid='GoReplace_label_find',
            i18n_domain='GoReplace',
        )
    ),

    TextField(
        name='replace',
        default='<a\\1href="http://gogo.bluedynamics.com"\\3> <!-- was: "\\2" -->',
        widget=TextAreaWidget(
            label='Replace',
            label_msgid='GoReplace_label_replace',
            i18n_domain='GoReplace',
        )
    ),

    BooleanField(
        name='regex',
        default="1",
        widget=BooleanField._properties['widget'](
            label='Regex',
            label_msgid='GoReplace_label_regex',
            i18n_domain='GoReplace',
        )
    ),

    LinesField(
        name='fields',
        default=["Title", "Description","Text"],
        widget=LinesField._properties['widget'](
            label='Fields',
            label_msgid='GoReplace_label_fields',
            i18n_domain='GoReplace',
        )
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

GoReplacement_schema = BaseSchema.copy() + \
    getattr(ATTopic, 'schema', Schema(())).copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class GoReplacement(ATTopic):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(ATTopic,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'GoReplacement'

    meta_type = 'GoReplacement'
    portal_type = 'GoReplacement'
    allowed_content_types = [] + list(getattr(ATTopic, 'allowed_content_types', []))
    filter_content_types = 0
    global_allow = 0
    content_icon = 'go_replacement.png'
    immediate_view = 'base_view'
    default_view = 'atct_topic_view'
    suppl_views = ()
    typeDescription = "GoReplacement"
    typeDescMsgId = 'description_edit_goreplacement'


    actions =  (


       {'action': "string:${object_url}/run",
        'category': "object",
        'id': 'run',
        'name': 'run',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = GoReplacement_schema

    ##code-section class-header #fill in your manual code here
    actions = ATTopic.actions + actions
    ##/code-section class-header

    # Methods

    security.declarePublic('wet_run')
    def wet_run(self):
        """
        """
        changecount = 0
        brains = self.queryCatalog(batch=False)
        for brain in brains:
            o = brain.getObject()
            for field in self.getFields():
                o_val = None
                r_val = None
                o_val = self.getValue(o, field)
                r_val = self.replaceValue(o, field)
                if o_val != r_val:
                    self.setValue(o, field, r_val)
                    changecount += 1
        return changecount

    security.declarePublic('getValue')
    def getValue(self, o, name):
        """
        """
        f = o.getField(name)
        if f:
            a = f.accessor
            return o[a]()
        else:
            val = getattr(o, name, None)
            if hasattr(val, '__call__'):
                val = val()
            return val

    security.declarePublic('setValue')
    def setValue(self, o, name, value):
        """
        """
        f = o.getField(name)
        if f:
            m = f.mutator
            o[m](value)
        elif name == 'Title':
            o.setTitle(value)
        elif name == 'Description':
            o.setDescription(value)
        else:
            summary = "Replace failed"
            message = "Can not set field %s @ %s" % (repr(name), repr(o))
            logger.log(logging.WARNING, '%s \n%s', summary, message)

    security.declarePublic('replaceValue')
    def replaceValue(self, o, name):
        """
        """
        val = self.getValue(o, name)
        if not val:
            return None
        if self.getRegex():
            if not getattr(self, '_reg', False):
                self._reg = re.compile(self.getFind())
            rep = self._reg.sub(self.getReplace(), val)
        else:
            rep = val.replace(self.getFind(), self.getReplace())
        return rep

    # Manually created methods

    def at_post_edit_script(self):
        self._reg = None



registerType(GoReplacement, PROJECTNAME)
# end of class GoReplacement

##code-section module-footer #fill in your manual code here
##/code-section module-footer



